Compare commits

...

11 Commits

7 changed files with 366 additions and 41 deletions

View File

@ -26,6 +26,7 @@ else
echo "Reader not running on $fifo"
exit 1
fi
echo "Reader running on $fifo: update"
echo "update" >$fifo
exit 0
fi

View File

@ -1,5 +1,11 @@
{
"fifo_dir" : "/tmp",
"fifo" : "update_controller_fifo",
"GIT_SSL_NO_VERIFY" : true
"fifo_dir" : "/tmp",
"fifo" : "update_controller_fifo",
"workspace" : "workspace",
"GIT_SSL_NO_VERIFY" : true,
"customer_id" : "281",
"zone_group" : "1",
"zone" : "1",
"customer_location" : "szeged",
"repository_path" : "https://git.mimbach49.de/GerhardHoffmann"
}

View File

@ -1,12 +1,17 @@
#!/bin/bash
set -x
fifo=""
customer_id=""
customer_repository=""
customer_location=""
customer_base_dir=""
source ./log_helpers.sh
source ./update_helpers.sh
source ./git_helpers.sh
source ./opkg_helpers.sh
source ./update_helpers.sh
init_fifo () {
trap "rm -f $fifo" EXIT
@ -25,31 +30,78 @@ init_fifo () {
}
read_config() {
local func="${FUNCNAME[0]}"
# check fifo settings
fifo_dir=$(cat "$1" | jq -r .fifo_dir)
if [ -z "$fifo_dir" ]; then
return 1
log_fatal "$func: fifo_dir not set in $1"
fi
fifo=$(cat "$1" | jq -r .fifo)
if [ -z "$fifo" ]; then
return 1
log_fatal "$func: fifo not set in $1"
fi
fifo="${fifo_dir}/$fifo"
log_debug "$func:${LINENO}: fifo is $fifo"
# check customer_id
customer_id="$(cat "$1" | jq -r .customer_id)"
if [ -z "$customer_id" ]; then
log_fatal "$func:${LINENO} customer_id not set in $1"
fi
customer_id="customer_$customer_id"
log_info "$func:${LINENO}: customer-id is $customer_id"
# check customer_repository
repository_path="$(cat "$1" | jq -r .repository_path)"
if [ -z "$repository_path" ]; then
log_fatal "$func:${LINENO}: repository path not set in $1"
fi
repository_path="${repository_path}/${customer_id}.git"
log_info "$func:${LINENO}: repository path is $repository_path"
# check zone_group
local zone_group="$(cat "$1" | jq -r .zone_group)"
if [ -z "$zone_group" ]; then
log_fatal "$func:${LINENO}: zone_group not set in $1"
fi
# check zone
local zone="$(cat "$1" | jq -r .zone)"
if [ -z "$zone" ]; then
log_fatal "$func:${LINENO}: zone not set in $1"
fi
# check customer_location
local customer_location="$(cat "$1" | jq -r .customer_location)"
if [ -z "$customer_location" ]; then
log_fatal "$func:${LINENO}: customer_location not set in $1"
fi
customer_base_dir="$PWD/workspace/${customer_id}/${customer_location}"
customer_base_dir="${customer_base_dir}/${zone_group}/${zone}"
log_info "$func:${LINENO}: customer-base-dir is $customer_base_dir"
return 0
}
wait_for_trigger() {
local func="${FUNCNAME[0]}"
if [[ "$1" -eq -1 ]]; then
# wait for external impulse
log_debug "$func:${LINENO}: waiting on $fifo"
if read line <$fifo; then
if [ "$line" = "quit" ] || [ "$line" = "update" ]; then
echo "$line"
log_debug "$func:${LINENO}: received=$line"
printf "%s\n" $line
fi
fi
else
sleep $1
echo "sleep"
log_debug "$func:${LINENO}: sleep"
fi
}
@ -110,6 +162,9 @@ check_for_apism() {
#
check_for_updates() {
# ismas_response=$(cat send_to_ismas.txt; sleep 1) | nc localhost 7778)
if ! pull_customer_repository customer_281; then
return 1
fi
return 0
}
@ -169,6 +224,7 @@ UpdateController() {
local try_lock_count=0
local try_unlock_count=0
local trigger_timeout=-1
local func="${FUNCNAME[0]}"
# read config parameters
# read_config
@ -186,7 +242,7 @@ UpdateController() {
fi
if $trigger_reboot; then
echo "CRITICAL send message to reboot the PSA"
log_crit "$func:${LINENO}: send message to reboot the PSA"
send_reboot_message_to_system_controller
continue
fi
@ -200,10 +256,10 @@ UpdateController() {
if [[ "$check_apism_count" -eq 5 ]]; then
trigger_reboot=true
check_apism_count=0
echo "ERROR APISM not working"
log_crit "$func:${LINENO}: ERROR APISM not working"
continue 2
fi
echo "[$check_apism_count]: $(date +'%Y-%m-%d %T') check APISM"
log_debug "$func:${LINENO}: [$check_apism_count]: check APISM"
sleep 60s
else
# APISM up and working
@ -212,16 +268,17 @@ UpdateController() {
fi
done
echo "$(date +'%Y-%m-%d %T') checking for updates..."
exit 1
log_debug "$func:${LINENO}: checking for updates..."
# exit 1
# Are there new updates available ?
if ! check_for_updates; then
echo "DEBUG no updates available"
log_info "$func:${LINENO}: DEBUG no updates available"
extract_changed_files
continue
fi
echo "$(date +'%Y-%m-%d %T') fetching updates..."
log_debug "$func:${LINENO}: fetching updates..."
exit 1
# Fetch new updates (using git)

View File

@ -1,34 +1,67 @@
#!/bin/bash
# set -x
source ./log_helpers.sh
GIT_SSL_NO_VERIFY=true
commit_before_pull=""
#
exec_git_command () {
local func="${FUNCNAME[0]}"
log_debug "$func:${LINENO} exec-ing $1"
# save the last commit before executing 'git pull'
save_commit_before_pull () {
# git reflog -> 46c5896 HEAD@{0}: commit: Made update_helpers.sh executable
commit_before_pull=$(git reflog | grep "HEAD@{0}" | cut -d" " -f1)
if ! [ -z "$commit_before_pull" ]; then
if grep -qE "^[[:xdigit:]]{6,}$" <<< $commit_before_pull; then
return 0
exec {fd}< <($1)
local ps_pid=$! # remember pid of process substitution
local git_result=""
while read t <&$fd; do
if ! [ -z "$t" ]; then
git_result="${git_result}$t"
fi
fi
commit_before_pull=""
return 1
done
exec {fd}>&- # close fd (i.e. process substitution)
wait $ps_pid # wait for the subshell to finish
git_result=$(printf "$git_result" | tr '\n' ' ')
printf "%s\n" $git_result
}
#
latest_commit () {
local func="${FUNCNAME[0]}"
# git reflog -> 46c5896 HEAD@{0}: commit: Made update_helpers.sh executable
local c=$(git reflog | grep "HEAD@{0}" | cut -d" " -f1)
if ! [ -z "$c" ]; then
if grep -qE "^[[:xdigit:]]{6,}$" <<< $c; then
log_debug "$func: commit -> $c"
printf "%s\n" $c
else
log_crit "$func: wrong format for commit c=$c"
printf ""
fi
else
log_crit "$func: 'git reflog' result empty"
printf ""
fi
}
# save_commit_before_pull
# fallback if something went wrong: revert to last valid commit
revert_to_commit_before_pull () {
local func="${FUNCNAME[0]}"
if ! [ -z "$commit_before_pull" ]; then
if grep -qE "^[[:xdigit:]]{6,}$" <<< $commit_before_pull; then
`git reset --hard "$commit_before_pull"`
if [ $? -eq 0 ]; then
log_info "$func: git reset --hard $commit_before_pull"
return 0
fi
log_crit "$func: 'git reset --hard $commit_before_pull' failed!"
fi
log_crit "$func: wrong format for commit_before_pull"
fi
log_crit "$func: empty commit_before_pull"
return 1
}
# revert_to_commit_before_pull
@ -36,6 +69,7 @@ revert_to_commit_before_pull () {
# clone the customer repository in ./UpdateController/workspace.
# this is done only once.
clone_customer_repository () {
local func="${FUNCNAME[0]}"
current_dir=${PWD##*/}
current_dir="./${current_dir:-/}"
if [ "$current_dir" = "./UpdateController" ]; then
@ -45,32 +79,163 @@ clone_customer_repository () {
# check if the directory is empty. If so, clone the
# customer repository
if ! find ./workspace -mindepth 1 -maxdepth 1 | read; then
echo "cloning ${1} ..."
log_debug "$func: cloning ${1} ..."
( cd ./workspace && git clone "$1" ; )
if [ $? -eq 0 ]; then
log_debug "$func: cloning ${1} done"
return 0
fi
fi
fi
return 1
}
# clone_customer_repository https://git.mimbach49.de/GerhardHoffmann/customer_281.git
# clone_customer_repository ->
# https://git.mimbach49.de/GerhardHoffmann/customer_281.git
pull_customer_repository () {
cd_customer_repository () {
# has to be called in ./UpdateController
local func="${FUNCNAME[0]}"
current_dir=${PWD##*/}
current_dir="./${current_dir:-/}"
if [ "$current_dir" = "./UpdateController" ]; then
repository_dir="./workspace/$1"
repository_dir="./workspace/${customer_id}"
if ! [[ -d "$repository_dir" ]]; then
printf "%s\n" "$repository_dir does not exist!" >&2
log_crit "$func:${LINENO}: $repository_dir does not exist!"
return 1
fi
if [ "$(cd $repository_dir && git pull)" = "Already up to date." ]; then
printf "%s\n" "$repository_dir already up to date." >&2
if ! cd $repository_dir; then
log_crit "$func:${LINENO}: cannot change to $repository_dir!"
return 1
fi
else
printf "%s\n" "${FUNCNAME[0]} not called in ./UpdateController" >&2
log_debug "$func:${LINENO}: cd to $repository_dir!"
return 0
fi
return 1
}
cd_home () {
if cd - &>/dev/null ; then
return 0
fi
return 1
}
pull_customer_repository () {
# has to be called in ./UpdateController
local func="${FUNCNAME[0]}"
if ! cd_customer_repository ; then
return 1
fi
local commit_before_pull=$(latest_commit)
if [ -z $commit_before_pull ]; then
cd_home ; return 1
fi
log_debug "$func:${LINENO}: commit_before_pull=$commit_before_pull"
exec {fd}< <(git pull)
local ps_pid=$! # remember pid of process substitution
local git_result=""
while read t <&$fd; do
if ! [ -z "$t" ]; then
git_result="${git_result}$t"
fi
done
exec {fd}>&- # close fd (i.e. process substitution)
wait $ps_pid # wait for the subshell to finish
if [ -z "$git_result" ]; then
log_warn "$func:${LINENO}: git result empty" ; cd_home;
return 1
fi
log_debug "$func:${LINENO} git-pull-result=${git_result}"
if [ "$git_result" = "Already up to date." ]; then
log_warn "$func:${LINENO}: $PWD already up to date."
cd_home ; return 1
fi
local commit_after_pull=$(latest_commit)
if [ -z $commit_after_pull ]; then
cd_home ; return 1
fi
log_debug "$func:${LINENO}: commit_after_pull=$commit_after_pull"
# Note: # 'git pull' is a 'git fetch' followed by a 'git merge'.
# Here's the fetch portion:
#
# remote: Counting objects: 11, done.
# remote: Compressing objects: 100% (5/5), done.
# remote: Total 7 (delta 2), reused 0 (delta 0)
#
# At this point, you've told the remote what you want.
# It finds all the objects it needs to give you,
# compresses them for faster transfer over the network,
# and then reports what it's sending you.
#
# Unpacking objects: 100% (7/7), done.
#
# You receive the pack (set of compressed objects) and unpack it.
#
# From ssh://my.remote.host.com/~/git/myproject
# * branch master -> FETCH_HEAD
# You've fetched the branch 'master' from the given remote;
# the ref FETCH_HEAD now points to it.
# Now we move on to the merge - precisely, git will merge
# FETCH_HEAD (the remote's master branch) into your current branch
# (presumably master).
#
#######################################################################
# here starts "message"
#
# Updating 9d447d2..f74fb21
# Fast forward
#
# It turns out that you haven't diverged from the remote's master branch,
# so the merge is a fast-forward (a trivial merge where it simply moves
# you forward in the history).
#
# Git notes the original position of your master branch (9d447d2)
# and the new position (f74fb21) it's been fast-forwarded to.
# If you had diverged from the remote's master branch,
# you'd see the output of a recursive merge here - Merge made
# by recursive, possibly along with some Auto-merged <file>
# and (oh no!) merge conflicts!
#
# szeged/1/1/etc/psa_config/device.conf | 13 +++++++------
# szeged/update.conf | 2 +-
# 2 files changed, 8 insertions(+), 7 deletions(-)
#
# Finally, it shows you the diffstat between the original and post-merge
# position of your master branch;
# this is basically what you'd get from
#
# git diff --stat master@{1} master.
#
update_commit="${commit_before_pull}..${commit_after_pull}"
if ! grep -qE ".*Updating\s+${update_commit}.*?" <<< $git_result; then
log_crit "$func:${LINENO}: no $update_commit in [ $git_result ]"
cd_home ; return 1
fi
return 0
}
# pull_customer_repository customer_281
changed_files () {
local func="${FUNCNAME[0]}"
if cd_customer_repository ; then
printf "%s\n" $(exec_git_command 'git diff --stat master@{1} master')
cd_home
fi
}

View File

@ -1,17 +1,70 @@
#!/bin/bash
# set -x
readonly DEBUG=0
readonly INFO=1
readonly WARN=2
readonly CRIT=3
readonly FATAL=4
readonly MAX_DEBUG_LEVEL=5
log_level=0
set_dbg_level () {
if [ $1 < $MAX_DEBUG_LEVEL ]; then
log_level=$1
fi
}
dbg_level () {
return $log_level
}
log() {
local log_file=/var/log/update_controller.log
if [ -f "$log_file" ]; then
touch $log_file
fi
if [ $(wc -l < $log_file) > 100000 ]; then
if [[ "$(wc -l < $log_file)" > "100000" ]]; then
# remove first line
sed -e 1d -i $log_file
fi
message="$(date +'%D_%T'): $*"
printf "$message\n"
printf "$message\n" >> $log_file
local msg="$(date +'%Y-%m-%d_%T'): $*"
printf "$msg\n" >&2
printf "$msg\n" >> $log_file
}
log_debug() {
if [ $log_level = $DEBUG ]; then
log "DEBUG $*"
fi
}
log_info() {
if [ $log_level -le $INFO ]; then
log "INFO $*"
fi
}
log_warn() {
if [ $log_level -le $WARN ]; then
log "WARN $*"
fi
}
log_crit() {
if [ $log_level -le $CRIT ]; then
log "CRIT $*"
fi
}
log_fatal() {
if [ $log_level -le $FATAL ]; then
log "FATAL $*"
log "exiting ..."
exit 1
fi
}
# log "test message1" "test message2"

View File

@ -3,7 +3,7 @@
# set -x
compute_md5 () {
execdownload_opkg {fd}< <(md5sum "$1") # open fd readable for P.S.
exec {fd}< <(md5sum "$1") # open fd readable for P.S.
cs_pid=$! # remember pid of P.S.
md5=""
while read t <&$fd; do

43
update_helpers.sh Executable file → Normal file
View File

@ -0,0 +1,43 @@
#!/bin/bash
# set -x
source ./log_helpers.sh
source ./git_helpers.sh
extract_changed_files () {
local func="${FUNCNAME[0]}"
local files=$(changed_files)
local updated_files=""
if [ -z $files ]; then
log_crit "$func:${LINENO} no changed files!"
else
if grep -qE "update.conf" <<< $files ; then
updated_files="${updated_files} update.conf"
if grep -qE "printer.conf" <<< $files ; then
updated_files="${updated_files} printer.conf"
fi
if grep -qE "emp.conf" <<< $files ; then
updated_files="${updated_files} emp.conf"
fi
if grep -qE "device.conf" <<< $files ; then
updated_files="${updated_files} device.conf"
fi
else
log_crit "$func:${LINENO} NO new revision of update.conf"
fi
fi
log_debug "$func:${LINENO} new revisions for $updated_files"
printf "$updated_files"
}
check_md5sum () {
local func="${FUNCNAME[0]}"
fn="/workspace/customer_281/szeged/1/1/etc/psa_config"
}